#!/usr/bin/perl
use lib '..';chdir '..';
$args={};/^\-?(\w+)=(['"]?)(.+)\2$/o and $$args{$1}=$3 foreach @ARGV;
%ARGS=(
	tpl=>[qw'template rxml t'],
	rules=>[qw'mapping rx r'],
	in=>[qw'input filein i'],
	out=>[qw'output fileout o']
);

foreach my$arg(keys %ARGS) {
	defined $args->{$arg} or $args->{$arg}=$args->{$_} foreach @{$ARGS{$arg}};
	die <DATA> unless length $args->{$arg}
}
local(
	$mapping_file, $template_file, $text_file_in, $text_file_out
)=@$args{+qw'rules tpl in out'};
#local($mapping_file, $template_file, $text_file_in, $text_file_out)=(
#	'config/news.rx',   #      
#	'config/news.rxml', #      
#	'res/in.html',          #   
#	'out1.html'          #   
#);

use RXParser;
local$rxp=RXParser->new;
	#    
$mapping=$rxp->rules(
	#       
			file=>$mapping_file
	#       
		)->prepare;
	#        $text_file
$parser =$rxp->parser(
	#     
			rules=>$mapping,
	#   ,   
			file=>$text_file_in
	#    $text_file  ,
	#   $mapping_file
		)->prepare;
	#       $text_file_out
	#    $template_file

$translator=$rxp->template(
	#         $text_file_in
			parser=>$parser,
	#      
			file=>$template_file
	#     $text_file_out
			#,output=>$text_file_out
	#      $template_file
		)->prepare;

	#      $template_file 
	#  $text_file_in   $text_file_out
$translator->saveAs(
		file=>$text_file_out
) or die <DATA>;

print '
	Successed! File "',
		$text_file_out,
	'" was created
';
exit 0;

__DATA__

################################################################################

                            Usage RXParser 2.0

	parse.pl - Universal text parser and translator.

	perl parse.pl -in=<in_file> -out=<out_file> -rules=<rules_file>
                                                -tpl=<template_file>

	perl parse.pl  in=<in_file>  out=<out_file>  rules=<rules_file>
                                                 tpl=<template_file>

	perl parse.pl  i=<in_file>  o=<out_file>  r=<rules_file>
                                              t=<template_file>

	PARAMETERS:

	in      - Input text filename to parse and translate
	rules   - File with rules for in-file decomposition
	tpl     - Template file with rules for output composition
	out     - Output text filename

///////////////////////////////////////////////////////////////////////////////
	Example:
	perl parse.pl -in=in.html -out=out.html -tpl=config/news.rxml
						-rules=config/news.rx

        Successed! File "out.html" was created
///////////////////////////////////////////////////////////////////////////////

	Shatrow Aleksey <cdch@yandex.ru>
	All rights reserved (c). Russia, Krasnodar, March 26, 2005

################################################################################
