package RXParser::Parser;
use base 'RXParser';

sub prepare {
	my $self=shift;
	$self->{rules}=shift  || $self->{rules}
					or $self->error('Input rules not found');
	$self->{file}=shift || $self->{file}
					or $self->error('Input filename not found');

	use fileops;

	my $file=&fileops::osreadfile($self->{file});study $file;
	my($q, $mr, $i, $key, $res, @keys)=(0, $self->{rules}{result});
	$self->{result}={};

	foreach $key (sort{$mr->{$a}{order}<=>$mr->{$b}{order}}keys %$mr) {
		$self->{result}{$key}={
			found=>[],
			info=>$mr->{$key}
		};
		$q=0;
		@keys=sort{$mr->{$key}{args}{$a}{order}<=>$mr->{$key}{args}{$b}{order}}
								keys%{$mr->{$key}{args}};
		pos($file)=0;
		while($file=~/$mr->{$key}{rx}/gc) {
			$res={
				'#'=>+$q++,
				'!'=>+pos $file
			};
			for($i=0; $i<@keys; $i++) {
				$res->{$keys[$i]}=$self->filter->prepare(${$i+1},
								$mr->{$key}{args}{$keys[$i]}{type})
			}
			push @{$self->{result}{$key}{found}}, $res
		}
	}
	+$self
}

+1;